/*

  File LUmat.h:

  definisce la classe LUmat, per la soluzione di sistemi lineari nxn
  attraverso la fattorizzazione LU.

*/


#ifndef LUmat_H

#define LUmat_H

class LUmat
{

 private:

   int dim;
   double ** mat;
   double * tmp;

 public:

   LUmat( int );                                            // Costruttore della classe
   ~LUmat( );                                               // Distruttore della classe
   void luFact( );                                          // Fattorizza LU la matrice
   void luSolve( double *, double * );                      // Risolve un sistema dati i termini noti
   void setMatrix( double * );                              // Definisce la matrice tramite un'altra matrice
   void setElement( int, int, double );                     // Definisce la matrice per elementi
   double getElement( int , int );                          // Estrae l'elemento i,j

};

#endif
